// Consumer.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

public class Consumer extends SwarmObjectImpl
	{
	// global variables for the class
	public int myBudget;
	public int myName;
	public int moneySpent;

	// constructor
	public Consumer(Zone aZone,int name,int budget)
		{
		super(aZone);
		myName=name;
		myBudget=budget;
		}

	// determines randomly whether the consumer goes to the market
	public int goToTheMarket()	// note the () when no arguments
		{
		int k;
		k=Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,1);
		return k;
		}

	// determines randomly how much is spent on the market
	public int spend()
		{
		moneySpent=Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,myBudget);
		return moneySpent;
		}

	// calculate remaining budget
	public int calculateRemainingBudget()
		{
		myBudget-=moneySpent;
		return myBudget;
		}

	// pass variables to other classes
	public int getConsumerName()
		{
		return myName;
		}

	public int getBudget()
		{
		return myBudget;
		}
	} // end of consumer class